<?php
//--------------------------------------------------------------------
// Weblog PHP script BlognPLUS
// http://www.blogn.org/
// Copyright Shoichi Takahashi
//
//--------------------------------------------------------------------
// *** MailForm Reader Module ***
// Author Yasuhiro Matsumoto
//
// mailform.php v1.0.1
//
// LAST UPDATE 2005/01/13
//
//--------------------------------------------------------------------
global $csvlib_loaded;
if (!$csvlib_loaded) {
	require "CSV.php";
	$csvlib_loaded = true;
}

function mail_encode($in_str, $charset) {
	$out_str = $in_str;
	if ($out_str && $charset) {
		$end = "?=";
		$start = "=?" . $charset . "?B?";
		$spacer = $end . "\r\n " . $start;
		$length = 75 - strlen($start) - strlen($end);
		$length = floor($length/2) * 2;
		$out_str = base64_encode($out_str);
		$out_str = chunk_split($out_str, $length, $spacer);
		$spacer = preg_quote($spacer);
		$out_str = preg_replace("/" . $spacer . "$/", "", $out_str);
		$out_str = $start . $out_str . $end;
	}
	return $out_str;
}

function send_mail($subject, $body) {
	$mailform_config = BLOGN_INIDIR."mailform.cgi";
	$mailconfig = csv_load($mailform_config);
	if (count($mailconfig)) {
		$mailconfig = $mailconfig[0];
	}
	$mail_to_name = $mailconfig[0];
	$mail_to_addr = $mailconfig[1];
	$mail_from_name = $mailconfig[2];
	$mail_from_addr = $mailconfig[3];

	$mail_header = "";
	$mail_header .= "From: " . mail_encode(mb_convert_encoding($mail_from_name, "iso-2022-jp", "utf-8"), "iso-2022-jp") . " <" . $mail_from_addr . ">\r\n";
	$mail_header .= "Content-type: text/plain; charset=iso-2022-jp\r\n";
	$mail_to = mail_encode(mb_convert_encoding($mail_to_name, "iso-2022-jp", "utf-8"), "iso-2022-jp") . " <" . $mail_to_addr . ">";
	$mail_subject = mail_encode(mb_convert_encoding($subject, "iso-2022-jp", "utf-8"), "iso-2022-jp");
	$mail_body = mb_convert_encoding($body, "iso-2022-jp", "utf-8");
	@mail($mail_to, $mail_subject, $mail_body, $mail_header);
}

if (isset($mailform_method)) {
	global $request_url;
	global $subject;
	global $body;
	chdir("../..");
	require "conf.php";
	switch($mailform_method) {
	case "sendmail":
		send_mail($subject, $body);
		header("Location: ".$request_url);
		exit;
		break;
	}
}

function blogn_mod_mailform($user, $skin) {
	global $mailform_config;

	$mailform = "";
	$request_url = $_SERVER["SCRIPT_NAME"]."?".$_SERVER["QUERY_STRING"];

	$mailform .= "<div style=\"font-size: 8px; text-align: left;\">\n";
	$mailform .= "<form action=\"module/mailform/mailform.php?\" method=\"post\">\n";
	$mailform .= "題名:<br><input type=\"text\" name=\"subject\" style=\"font-size: 8px;\"><br>";
	$mailform .= "本文:<br><textarea type=\"text\" name=\"body\" style=\"font-size: 8px;\"></textarea>";
	$mailform .= "<input type=\"submit\" name=\"sendmail\" value=\"送信\" style=\"font-size: 8px;\">";
	$mailform .= "<input type=\"hidden\" name=\"request_url\" value=\"".$request_url."\">";
	$mailform .= "<input type=\"hidden\" name=\"mailform_method\" value=\"sendmail\">";
	$mailform .= "</form>";
	$mailform .= "</div>\n";
	return preg_replace ("/\{MAILFORM\}/", $mailform, $skin);
}

$mailform_config = BLOGN_INIDIR."mailform.cgi";
$mailconfig = csv_load($mailform_config);
if (count($mailconfig)) {
	$blogn_skin = blogn_mod_mailform($blogn_user, $blogn_skin);
}
?>
